{% load static %}

<head>
  <title>Pruebas de escritura</title>

  {% include 'sub_templates/base.html' %}
  {{'caja_gris/escritura_consulta.scss'|css_compiler|safe}}

  <script type="text/javascript">
    $( document ).ready( function (){
      // aplicar disable_value a los selected existentes
      $('#existant-expected-responses .existant-expected-response select').each(function(i,elem){
        disable_value(elem);
      })

      $('#new-header input, #new-body-form-data input, #new-expected-response input, #new-expected-response select,\
        #new-domain input, #new-environment-variable input').on('change', (e)=>{
        $(e.currentTarget.parentElement).children('.plus').addClass('edited')
      })

      start_unsaved_changes_messages();
    })

    function select_input_file(elem){
      let file_input_elem = $(elem).parent().parent().children('input');
      let form_data_elem = file_input_elem.parent().parent()

      file_input_elem.change(function(e){
        var fileName = e.target.files[0].name;

        form_data_elem.children('.val').val(fileName);
        form_data_elem.children('.val').attr('disabled', true);
        form_data_elem.children('.input-file').children('.file-buttons').html(
          '<a onclick="select_input_file(this)" title="Modificar Archivo Adjunto">{{'paperclip-solid.svg'|svgColor:'var(--info)'|safe}}</a>'
        );
      });
      file_input_elem.click();
    }

    function action_test_selected(data){
      window.location.href = 'http://'+window.location.host+'/{{project_id}}/caja_gris/escritura/consulta/'+data;
    }

    function delete_data(elem){
      let parent = elem.parentNode.parentNode
      parent.remove()
      unsaved_changes()
    }

    function new_data(elem){
      let new_elem = elem.parentNode.parentNode
      let added_element = $(new_elem).clone()
      let existant_elements = new_elem.parentNode.children[1]

      added_element.removeAttr("id")
      $(existant_elements).append(added_element)
      $(added_element).children('select').val($(new_elem).children('select').val())

      let plus_times_elem = added_element.children(".plus")
      plus_times_elem.removeClass()
      plus_times_elem.addClass("times")
      plus_times_elem.html('<a onclick="delete_data(this);">{{"times-solid.svg"|svgColor:"var(--danger)"|safe}}</a>')

      $(new_elem).children('input').val('')
      $(new_elem).children('select').val('')
      $(new_elem).children(".plus").removeClass('edited')
      // solo para form data de archivos
      $(new_elem).children('input').removeAttr('disabled')
      $(new_elem).children('.input-file').children('.file-buttons').html(
        '<a onclick="select_input_file(this)" title="Adjuntar Archivo">{{'paperclip-solid.svg'|svgColor:'var(--secondary)'|safe}}</a>'
      )
    }

    function disable_value(elem){
      value_elem = $(elem.parentNode).children(".val")
      value_disable_selects = ["exist", "is_null", "is_text", "is_number", "is_list", "is_dictionary"]
      if (value_disable_selects.includes(elem.value)){
        value_elem.attr("disabled", true);
      }
      else{
        value_elem.removeAttr("disabled");
      }
    }

    function previsualize_response(){
      $('#response-content .response-content').html('<iframe id="iframe_response"></iframe>')
      a = $.parseHTML("{{test.response.data|stringify_data}}")
      $('#iframe_response')[0].contentDocument.write(a[0].wholeText)
    }


    function save_environment_variables(){
      let domains = {}
      $('#existant-domains').children().each((i,elem)=>{
        inputs = $(elem).children('input');
        domains[inputs[0].value] = inputs[1].value;
      });

      let variables = {}
      $('#existant-environment-variables').children().each((i,elem)=>{
        inputs = $(elem).children('input');
        variables[inputs[0].value] = inputs[1].value;
      });

      $.ajax({
        url: '/{{project_id}}/environment/update',
        type: 'POST',
        data: {
          'clean_domains': true,
          'clean_variables': true,
          'domain': domains,
          'variable': variables,
        },
        success: function(result){
          $('#environment-variables-modal').modal('hide');
          let domains_select = $('.content .route select.dns')
          let selected = domains_select.val()
          domains_select.html('<option value=""> Seleccionar un dominio </option>')
          for (var i = 0; i < result['domains'].length; i++) {
            domains_select.append('<option value="'+result['domains'][i]['value']+'">'+result['domains'][i]['variable']+'</option>')
          }
          domains_select.val(selected);
          push_alert('Variables de entorno modificadas correctamente', 'alert-success');
        },
        error: function(result){
          console.log(result);
          alert('Ocurrio un error inesperado');
        }
      });
    }

    function save_request(){
      let form_data = new FormData();

      method = $('.route .method').val();
      domain = $('.route .dns').val();
      route = $('.route .path').val();
      json_data = $('#nav-body-json').val()

      headers = {};
      $('#existant-headers').children().each((i, elem)=>{
        elem = $(elem)
        headers[elem.children('.var').val()] = {
          'val': elem.children('.val').val(),
          'desc': elem.children('.desc').val()
        }
      });
      // headers = JSON.stringify(headers)


      body_form_datas = {};
      $('#existant-body-form-datas').children().each((i, elem)=>{
        elem = $(elem)
        if (elem.children('.input-file').children('input').val() != ''){
          form_data.append(elem.children('.var').val(), elem.children('.input-file').children('input')[0].files[0])
        }
        // else{
        body_form_datas[elem.children('.var').val()] = {
          'val': elem.children('.val').val(),
          'desc': elem.children('.desc').val()
        }
        // }
      });
      // body_form_datas = JSON.stringify(body_form_datas)


      expected_responses = [];
      $('#existant-expected-responses').children().each((i, elem)=>{
        elem = $(elem)
        expected_responses.push({
          'var': elem.children('.var').val(),
          'comp': elem.children('.comp').val(),
          'val': elem.children('.val').val(),
        })
      });
      // expected_responses = JSON.stringify(expected_responses)

      let data = {
        'method': method,
        'domain': domain,
        'route': route,
        'headers': headers,
        'body_form_datas': body_form_datas,
        'json_data': json_data,
        'expected_responses': expected_responses
      }

      form_data.append('data', JSON.stringify(data))

      $.ajax({
        url: '/queries/save_request/{{test_id}}',
        type: 'POST',
        data: form_data,
        cache: false,
        contentType: false,
        processData: false,
        success: function(result){
          //aqui enviar un message de que funciono
          if('warning' in result){
            //aqui enviar un message
            alert(result['warning'])
          }
          else{
            //aqui enviar un message
            localStorage.clear();
            window.location.reload();
          }
        },
        error: function(result){
          console.log(result);
          alert('Ocurrio un error inesperado');
        }
      });
    }

    function execute_query(){
      $.ajax({
        url: '/queries/execute_query/{{test_id}}',
        type: 'POST',
        success: function(result){
          //aqui enviar un message de que funciono
          window.location.reload();
        },
        error: function(result){
          console.log(result);
          alert('Ocurrio un error inesperado');
        }
      });
    }
  </script>
</head>

<body>
  {% include 'sub_templates/left_nav_bar.html' %}

  <div class="back-button">
    <a href="/{{project_id}}/caja_gris">{{'arrow-left-solid.svg'|svgColor:'var(--secondary)'|safe}}</a>
  </div>
  <div>
    {% if test.status == 'built' %}
    <div class="test-status built" data-toggle="tooltip" onclick="toogle_test_status(this, '{{test_type}}', '{{test_id}}');" title="Marcar prueba como 'En construcción'"> Construida </div>
    {% else %}
    <div class="test-status in-construction" data-toggle="tooltip" onclick="toogle_test_status(this, '{{test_type}}', '{{test_id}}');" title="Marcar prueba como 'Construida'"> En construcción </div>
    {% endif %}
  </div>
  <div class="content">
    <div class="big-container">
      <div class="header">
        <div class="title"> {{title}} </div>
        <button class="environment-variables btn btn-info" data-toggle="modal" data-target="#environment-variables-modal"> Variables de entorno<br>del proyecto</button>
      </div>

      <div class="route">
        <select name="method" class="custom-select method">
          {% for method in options_methods %}
          <option value="{{method.val}}" {% if test.method == method.val %} selected {% endif %}> {{method.var}} </option>
          {% endfor %}
        </select>
        <select name="dns" class="custom-select dns" {% if not existant_domains %} data-toggle="tooltip" data-placement="top" data-html="true" title="Se debe agregar 'Dominios' a las variables de entorno del proyecto" {% endif %}>
          <option value=""> Seleccionar un dominio </option>
          {% for domain in existant_domains %}
          <option value="{{domain.val}}" {% if test.domain.value == domain.val %} selected {% endif %}> {{domain.var}} </option>
          {% endfor %}
        </select>
        <input class="form-control path" type="text" name="path" placeholder="Ruta especifica de esta consulta" value="{{test.route}}">
        <button id="execute_test" class="btn btn-info send" onclick="execute_query();">
          Enviar
        </button>
        <button id="save_test" class="btn btn-outline-info save" onclick="save_request();">
          Guardar
        </button>
      </div>

      <div class="send-data">
        <nav class="navbar-light bg-light">
          <div class="nav nav-tabs" role="tablist">
            <a class="navbar-item nav-link" id="nav-headers-tab" data-toggle="tab" href="#nav-headers" role="tab" aria-controls="nav-headers" aria-selected="false">Headers</a>
            <a class="navbar-item nav-link{% if existant_body_form_datas %} active{% endif %}" id="nav-body-form-data-tab" data-toggle="tab" href="#nav-body-form-data" role="tab" aria-controls="nav-body-form-data" aria-selected="true">Body as form-data</a>
            <a class="navbar-item nav-link{% if not existant_body_form_datas %} active{% endif %}" id="nav-body-json-tab" data-toggle="tab" href="#nav-body-json" role="tab" aria-controls="nav-body-json" aria-selected="false">Body as json</a>
          </div>


          <!-- Headers -->
          <div class="tab-pane fade" id="nav-headers" role="tabpanel" aria-labelledby="nav-headers-tab">
            <div class="head-row">
              <label class="col-3">Variable</label>
              <label class="col-3">Valor</label>
              <label class="col-5">Descripción</label>
            </div>
            <!-- Variables existentes -->
            <div id="existant-headers">
              {% for header in existant_headers %}
              <div class="existant-header form-data">
                <input class="col-3 form-control var" type="text" placeholder="Agregar una variable" value="{{header.var}}" required>
                <input class="col-3 form-control val" type="text" placeholder="Valor" value="{{header.val}}" required>
                <input class="col-5 form-control desc" type="text" placeholder="Descripción (opcional)" value="{{header.desc}}">
                <div class="times">
                  <a onclick="delete_data(this);">{{'times-solid.svg'|svgColor:'var(--danger)'|safe}}</a>
                </div>
              </div>
              {% endfor %}
            </div>
            <!-- Agregar nueva variable -->
            <div id="new-header" class="form-data">
              <input class="col-3 form-control var" type="text" placeholder="Agregar una variable" required>
              <input class="col-3 form-control val" type="text" placeholder="Valor" required>
              <input class="col-5 form-control desc" type="text" placeholder="Descripción (opcional)">
              <div class="plus" data-toggle="tooltip" data-placement="left">
                <a onclick="new_data(this);">{{'plus-solid.svg'|svgColor:'var(--info)'|safe}}</a>
              </div>
            </div>
          </div>


          <!-- Body as form-data -->
          <div class="tab-pane fade{% if existant_body_form_datas %} show active{% endif %}" id="nav-body-form-data" role="tabpanel" aria-labelledby="nav-body-form-data-tab">
            <div class="head-row">
              <label class="col-3">Variable</label>
              <label class="col-3">Valor</label>
              <label class="col-5">Descripción</label>
            </div>
            <!-- Variables existentes -->
            <div id="existant-body-form-datas">
              {% for body_form in existant_body_form_datas %}
              <div class="existant-body-form-data form-data">
                <input class="col-3 form-control var" type="text" placeholder="Agregar una variable" value="{{body_form.var}}" required>
                <input class="col-3 form-control val" type="text" placeholder="Valor" value="{{body_form.val}}" required {% if body_form.file != "" and body_form.file != None %}disabled{% endif %}>
                <div class="input-file">
                  <input type="file" hidden="true">
                  <div class="file-buttons">
                    {% if body_form.file != "" and body_form.file != None %}
                    <a href="{{body_form.file.url}}" title="Descargar Archivo">{{'download-solid.svg'|svgColor:'var(--info)'|safe}}</a>
                    {% else %}
                    <a onclick="select_input_file(this)" title="Adjuntar Archivo">{{'paperclip-solid.svg'|svgColor:'var(--secondary)'|safe}}</a>
                    {% endif %}
                  </div>
                </div>
                <input class="col-5 form-control desc" type="text" placeholder="Descripción (opcional)" value="{{body_form.desc}}">
                <div class="times">
                  <a onclick="delete_data(this);">{{'times-solid.svg'|svgColor:'var(--danger)'|safe}}</a>
                </div>
              </div>
              {% endfor %}
            </div>
            <!-- Agregar nueva variable -->
            <div id="new-body-form-data" class="form-data">
              <input class="col-3 form-control var" type="text" placeholder="Agregar una variable" required>
              <input class="col-3 form-control val" type="text" placeholder="Valor" required>
              <div class="input-file">
                <input type="file" hidden="true">
                <div class="file-buttons">
                  <a onclick="select_input_file(this)" title="Adjuntar Archivo">{{'paperclip-solid.svg'|svgColor:'var(--secondary)'|safe}}</a>
                </div>
              </div>
              <input class="col-5 form-control desc" type="text" placeholder="Descripción (opcional)">
              <div class="plus" data-toggle="tooltip" data-placement="left">
                <a onclick="new_data(this);">{{'plus-solid.svg'|svgColor:'var(--info)'|safe}}</a>
              </div>
            </div>

          </div>


          <!-- Body as json -->
          <textarea class="form-control tab-pane fade{% if not existant_body_form_datas %} show active{% endif %}" id="nav-body-json" role="tabpanel" aria-labelledby="nav-body-json-tab" placeholder='Parametros que se deben enviar en la consulta, en formato JSON
Ej:{
      "username": "ejemplo",
      "password": "password_ejemplo"
}'>{{existant_json_data}}</textarea>

        </nav>
      </div>
      <div class="response">
        <div class="expected-response">
          <div class="collapse-toggle{% if test.response %} collapsed{% endif %}" onclick="toggle_chevron(this);" data-toggle="collapse" href="#expected-response-body" role="button" aria-expanded="{% if test.response %}false{% else %}true{% endif %}">
            Respuesta Esperada {% if test.response.satisfied != '' and test.response.satisfied != None %}<span class="stisfied">({% if test.response.satisfied %}Correcta{% else %}Con problemas{% endif %})</span>{% endif %}
            {% if test.response %}
              {{'right'|chevron:'var(--white)'|safe}}
            {% else %}
              {{'down'|chevron:'var(--white)'|safe}}
            {% endif %}
          </div>
          <div id="expected-response-body" class="collapse{% if not test.response %} show{% endif %}">
            <div class="expected-response-body">
              <div class="head-row">
                <label class="col-3">Variable</label>
                <label class="col-4">Tipo de comparación</label>
                <label class="col-3">Valor</label>
              </div>
              <!-- Variables existentes -->
              <div id="existant-expected-responses">
                {% for expected_response in existant_expected_responses %}
                <div class="existant-expected-response satisfied-{{expected_response.satisfied}} form-data">
                  <input class="col-3 form-control var" type="text" placeholder="Agregar una variable" value="{{expected_response.var}}">
                  <select class="col-4 custom-select form-control comp" onchange="disable_value(this);">
                    {% for comparation in options_expected_responses %}
                    <option value="{{comparation.val}}" {% if expected_response.comp == comparation.val %}selected{% endif %}>{{comparation.var}}</option>
                    {% endfor %}
                  </select>
                  <input class="col-4 form-control val" type="text" placeholder="Valor" value="{{expected_response.val}}">
                  <div class="times">
                    <a onclick="delete_data(this);">{{'times-solid.svg'|svgColor:'var(--danger)'|safe}}</a>
                  </div>
                </div>
                {% endfor %}
              </div>
              <!-- Agregar nueva variable -->
              <div id="new-expected-response" class="form-data">
                <input class="col-3 form-control var" type="text" placeholder="Agregar una variable" value="{{expected_response.var}}">
                <select class="col-4 custom-select form-control comp" onchange="disable_value(this);">
                  <option value=""> ----- </option>
                  {% for comparation in options_expected_responses %}
                  <option value="{{comparation.val}}">{{comparation.var}}</option>
                  {% endfor %}
                </select>
                <input class="col-4 form-control val" type="text" placeholder="Valor" value="{{expected_response.val}}">
                <div class="plus" data-toggle="tooltip" data-placement="left">
                  <a onclick="new_data(this);">{{'plus-solid.svg'|svgColor:'var(--info)'|safe}}</a>
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="obtained-response">
          <div class="collapse-toggle{% if not test.response %} collapsed{% endif %}" onclick="toggle_chevron(this);" data-toggle="collapse" href="#response-content" role="button" aria-expanded="{% if test.response %}true{% else %}false{% endif %}">
            Respuesta Obtenida {% if test.response %} <span class="date">({{test.response.date}})</span> {% endif %}
            {% if test.response %}
              {{'down'|chevron:'var(--white)'|safe}}
            {% else %}
              {{'right'|chevron:'var(--white)'|safe}}
            {% endif %}
          </div>
          <div id="response-content" class="collapse{% if test.response %} show{% endif %}">
            <div class="response-content">
              {% if test.response.responseType == 'html' %}
              <div>
                <button class="btn btn-secondary centerX" onclick="previsualize_response()">Previsualizar respuesta</button>
              </div>
              {% endif %}
              <pre>{{test.response|json_response_formater}}</pre>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>

  <!-- Modal variables de entorno -->
  <div class="modal fade" id="environment-variables-modal" tabindex="-1" role="dialog" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered" role="document">
      <div class="modal-content">
        <div class="modal-header align-items-center">
          <h5 class="modal-title" id="new-test-title">Modificar variables de entorno</h5>
          <div class="helper" style="width: 1.5rem; margin-left: 1rem;" data-toggle="tooltip" data-html="true" 
            title="Las variables de entorno son utilizadas para facilitar el manejo de datos cuando hay informacion que constantemente puede cambiar.<br>Para utilizarlas, se pueden utilizar en cualquier input, escribiendo el nombre de la variable de entorno encerrada en llaves y corchetes <br> ej: {[nombre_variable_entorno]} <br> lo que traducirá el nombre de la variable en el valor que ésta posea">
            {{'question-circle-regular.svg'|svgColor:'var(--secondary)'|safe}}
          </div>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>

        </div>
        <div class="modal-body" id="environment-variables-form">
          <div class="container">

            <div class="domains">
              <div class="head-row">
                <label class="col-5">Dominio</label>
                <label class="col-6">Valor</label>
              </div>
              <!-- Variables existentes -->
              <div id="existant-domains">
                {% for domain in existant_domains %}
                <div class="existant-domain form-data">
                  <input class="col-5 form-control var" type="text" placeholder="Agregar un dominio" value="{{domain.var}}" required>
                  <input class="col-6 form-control val" type="text" placeholder="Valor" value="{{domain.val}}" required>
                  <div class="times">
                    <a onclick="delete_data(this);">{{'times-solid.svg'|svgColor:'var(--danger)'|safe}}</a>
                  </div>
                </div>
                {% endfor %}
              </div>
              <!-- Agregar nueva variable -->
              <div id="new-domain" class="form-data">
                <input class="col-5 form-control var" type="text" placeholder="Agregar una variable" required>
                <input class="col-6 form-control val" type="text" placeholder="Valor" required>
                <div class="plus" data-toggle="tooltip" data-placement="top">
                  <a onclick="new_data(this);">{{'plus-solid.svg'|svgColor:'var(--info)'|safe}}</a>
                </div>
              </div>
            </div>

            <div class="environment-variables">
              <div class="head-row">
                <label class="col-5">Variable de entorno</label>
                <label class="col-6">Valor</label>
              </div>
              <!-- Variables existentes -->
              <div id="existant-environment-variables">
                {% for environment_variable in existant_environment_variables %}
                <div class="existant-environment-variable form-data">
                  <input class="col-5 form-control var" type="text" placeholder="Agregar un dominio" value="{{environment_variable.var}}" required>
                  <input class="col-6 form-control val" type="text" placeholder="Valor" value="{{environment_variable.val}}" required>
                  <div class="times">
                    <a onclick="delete_data(this);">{{'times-solid.svg'|svgColor:'var(--danger)'|safe}}</a>
                  </div>
                </div>
                {% endfor %}
              </div>
              <!-- Agregar nueva variable -->
              <div id="new-environment-variable" class="form-data">
                <input class="col-5 form-control var" type="text" placeholder="Agregar una variable" required>
                <input class="col-6 form-control val" type="text" placeholder="Valor" required>
                <div class="plus" data-toggle="tooltip" data-placement="top">
                  <a onclick="new_data(this);">{{'plus-solid.svg'|svgColor:'var(--info)'|safe}}</a>
                </div>
              </div>
            </div>

          </div>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-secondary" data-dismiss="modal">Cancelar</button>
          <button type="submit" class="btn btn-primary" onclick="save_environment_variables();">Guardar</button>
        </div>
      </div>
    </div>
  </div>

</body>